/* ScriptExecController */

#import <Cocoa/Cocoa.h>

//limits
#define	kMaxFileArguments		1024
#define	kMaxPathLength			1024

// execution modes
#define	kNormalExecution	0
#define	kPrivilegedExecution	1

// output modes
#define	kNoOutput		1
#define	kProgressBarOutput	2
#define	kTextOutput		3

@interface ScriptExecController : NSObject
{
    IBOutlet id cancelButton;
    IBOutlet id messageTextField;
    IBOutlet id progressBar;
	IBOutlet id progressWindow;
	
	IBOutlet id textOutputWindow;
	IBOutlet id textOutputCancelButton;
	IBOutlet id textOutputTextField;
	IBOutlet id textOutputProgressIndicator;
	
	//menu items
	IBOutlet id hideMenuItem;
	IBOutlet id quitMenuItem;
	IBOutlet id aboutMenuItem;
	
	NSTask			*task;

	NSPipe			*outputPipe;
	NSFileHandle	*readHandle;
	NSString		*outputStr;

	NSMutableArray  *arguments;
	NSMutableArray  *fileArgs;

	NSString		*interpreter;
	NSString		*scriptPath;
	NSString		*appName;

	int			execStyle;
	int			outputType;
	int			isDroppable;
	int			remainRunning;
	
	BOOL		isTaskDone;
	BOOL		isTaskStarted;
}
- (IBAction)cancel:(id)sender;
- (void)executeScript;
- (void)loadSettings;
- (void)taskFinished;

@end
