//
//  FileTypesList.m
//  Platypus
//
//  Created by Sveinbjorn Thordarson on Tue Aug 10 2004.
//  Copyright (c) 2004 __MyCompanyName__. All rights reserved.
//

#import "TypesList.h"


@implementation TypesList

- (id) init
{
		items = [[NSMutableArray alloc] init];
		return self;
}

- (NSString *)getFileAtIndex:(int)index
{
	return ([items objectAtIndex: index]);
}

- (int)numberOfRowsInTableView:(NSTableView *)aTableView
{
	return ([items count]);
}

- (id)tableView:(NSTableView *)aTableView objectValueForTableColumn:(NSTableColumn *)aTableColumn row:(int)rowIndex
{
	return ([items objectAtIndex: rowIndex]);
}

- (void) addType: (NSString *)suffix
{
	[items addObject: suffix];
}

- (BOOL) hasType: (NSString *)suffix
{
	int i;
	for (i = 0; i < [items count]; i++)
	{
		if ([[items objectAtIndex: i] isEqualToString: suffix])
			return YES;
	}
	return NO;
}

- (BOOL) hasAllTypes
{
	int i;
	for (i = 0; i < [items count]; i++)
	{
		if ([[items objectAtIndex: i] isEqualToString: @"*"])
			return YES;
	}
	return NO;
}

- (void) clearList
{
	[items removeAllObjects];
}

- (int) numTypes
{
		return ([items count]);
}

- (void) removeType: (int)index
{
	if ([items count] > 0)
		[items removeObjectAtIndex: index];
}

- (NSDictionary *) getDictionaryForTypes: (NSString *)role
{
	NSDictionary	*dict;
	dict = [NSDictionary dictionaryWithObjectsAndKeys:
								[NSArray arrayWithArray: items], @"CFBundleTypeExtensions",
								[NSArray arrayWithObjects: @"fold", @"****", nil], @"CFBundleTypeOSTypes",//so we can open folders
								role, @"CFBundleTypeRole", nil];
	return dict;
}
@end
