#include <Carbon/Carbon.h>


/************************************************************************************
**  DEFINITIONS
************************************************************************************/
#pragma mark - definitions

//script types
#define		kShellScriptType	1
#define		kPerlScriptType		2
#define		kPythonScriptType	3
#define		kRubyScriptType		4
#define		kAppleScriptType	5
#define		kTclScriptType		6

// executable names for different script types

#define		kShellScriptExec	"shellexec"
#define		kPerlScriptExec		"perlexec"
#define		kPythonScriptExec	"pythonexec"
#define		kRubyScriptExec		"rubyexec"
#define		kAppleScriptExec	"osaexec"
#define		kTclScriptExec		"tclexec"

//script type suffices
#define		kShellScriptSuffix	".sh"
#define		kPerlScriptSuffix	".pl"
#define		kPythonScriptSuffix	".py"

#define		kRubyScriptSuffix	".rb"
#define		kRubyScriptSuffix2	".rbx"

#define		kAppleScriptSuffix	".applescript"
#define		kAppleScriptSuffix2	".osa"

#define		kTclScriptSuffix	".tcl"




#define		kIconFileSuffix		".icns"


//number of icons available
#define		kNumIcons		8
#define		kCustomIcon		-1
#define		kDefaultIcon	3

//author
#define		kAuthorEmail		"sveinbt@hi.is"
#define		kPlatypusWebsite	"http://raunvis.hi.is/~ssv/platypus.html"

//default settings
#define		kDefaultAppName		"MyApp"

//limits
#define		kMaxFileNameLength	255
#define		kMaxPathLength		2048



/************************************************************************************
**  PROTOTYPES
************************************************************************************/
#pragma mark - prototypes


	// main.c
	int main(int argc, char* argv[]);
	void QuitApp (void);

	OSErr InitHandlers (void);
	OSErr InitPaths (char *argvZero);
	OSErr InitNib (WindowRef *window);
	OSErr InitControls (void);
	OSErr InitIcons (void);

	OSErr NewPlatypusWindow (WindowRef window);
	void ClosePlatypusWindow (WindowRef window);

	OSErr CreateScriptApplication (void);
	OSErr CreateScriptApplicationFromFSSpec (FSSpec fileSpec);
	
	OSErr SetIcon (short iconNum);
	OSErr SetCustomIcon (char *path, FSSpec fileSpec);
	void SetMenuStatus (void);
	
	OSErr NavigationPutPath (Str255 defaultName, Str255 promptMessage, char *path);
	OSErr NavigationGetPath (char *navPath);
	OSErr NavigationGetFSSpec (FSSpec *file);
	OSErr NavigationPutFSSpec (Str255 message, Str255 defaultName, FSSpec *theFile);
	pascal Boolean NavFilterProc (AEDesc* theItem, void* info,  NavCallBackUserData callBackUD, NavFilterModes filterMode);

	static pascal OSStatus PlatypusCommandHandler (EventHandlerCallRef inCallRef, EventRef inEvent, void * inUserData);
	static pascal OSStatus PlatypusWindowHandler (EventHandlerCallRef inCallRef, EventRef inEvent, void * inUserData);
	static pascal OSStatus PlatypusAboutWindowHandler (EventHandlerCallRef inCallRef, EventRef inEvent, void *inUserData);
	static OSErr PlatypusReopenAEHandler( const AppleEvent *appleEvt, AppleEvent* reply, UInt32 refcon );
	static OSErr PlatypusOpenDocAEHandler(const AppleEvent *theAppleEvent, AppleEvent *reply, long refCon);
	static pascal OSErr PlatypusDragHandler (WindowPtr theWindow, void *handlerRefCon, DragReference theDrag);
	
	// util.c

	IconRef RegisterIcon( FourCharCode inCreator, FourCharCode inType, const char* inName );
	void RedAlert (Str255 errorString, Str255 expStr);
	void RedFatalAlert (Str255 errorString, Str255 expStr);
	void DoCautionAlert (Str255 errorString, Str255 expStr);
	void YellowAlert (Str255 errorString, Str255 expStr);
	void OpenURL (char *url);
	void SendMail (char *email);
	short UnixIsFolder (char *path);
	void CutFileFromPath (char *path);
	OSStatus FSMakePath(FSSpec file, UInt8 *path, UInt32 maxPathSize);
	char* GetFileSuffix (char *name);
	short GetScriptType (char *name);
	char* CutSuffix (char *name);
	char* GetFileNameFromPath (char *name);


/************************************************************************************
**  STRUCTURES
************************************************************************************/
#pragma mark - structures

typedef struct
{
    IconRef	icon;
    char	iconName[255];
    char	fileName[2048];

} PlatypusIconStruct;




