#!/usr/bin/perl

use Shell;

$appPath = $ARGV[0];
$appName = $ARGV[1];
$scriptPath = $ARGV[2];
$execPath = $ARGV[3];
$iconPath = $ARGV[4];
$iconName = $ARGV[5];
$output = $ARGV[6];
$interpreter = $ARGV[7];
$authorized = $ARGV[8];

$appLoc = "$appPath/$appName.app";

mkdir($appLoc);
mkdir("$appLoc/Contents");
mkdir("$appLoc/Contents/MacOS");
mkdir("$appLoc/Contents/Resources");

########### Copy relevant files over to new app bundle ##############

cp($execPath, "$appLoc/Contents/MacOS/$appName");
cp($scriptPath, "$appLoc/Contents/Resources/script");
cp("$iconPath/$iconName", "$appLoc/Contents/Resources/$iconName");

#if ($output eq "Text")
#{
#	cp("-R", "$iconPath/MenuBar.nib", "$appLoc/Contents/Resources/MenuBar.nib");
#	cp("-R", "$iconPath/TextWindow.nib", "$appLoc/Contents/Resources/TextWindow.nib");
#}
#elsif ($output eq "ProgressBar")
#{
#	cp("-R", "$iconPath/ProgressWindow.nib", "$appLoc/Contents/Resources/ProgressWindow.nib");
#}

########### Generate text file containing interpreter ##############

open(FILE, "+>$appLoc/Contents/Resources/interpreter");
print FILE $interpreter;
close(FILE);

########### Generate text file containing output type ##############

open(FILE, "+>$appLoc/Contents/Resources/outputType");
print FILE $output;
close(FILE);


########### Generate text file containing authority required type ##############

open(FILE, "+>$appLoc/Contents/Resources/auth");
if ($authorized eq "1")
{
	print FILE "Auth";
}
else
{
	print FILE "NoAuth"
}
close(FILE);


########### Create Info.plist ##############

open(FILE, "+>$appLoc/Contents/Info.plist");
print FILE <<"EOF";
<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE plist PUBLIC "-//Apple Computer//DTD PLIST 1.0//EN" "http://www.apple.com/DTDs/PropertyList-1.0.dtd">
<plist version="1.0">
<dict>
	<key>CFBundleDevelopmentRegion</key>
	<string>English</string>
	<key>CFBundleExecutable</key>
	<string>$appName</string>
	<key>CFBundleIconFile</key>
	<string>$iconName</string>
	<key>CFBundleInfoDictionaryVersion</key>
	<string>6.0</string>
	<key>CFBundlePackageType</key>
	<string>APPL</string>
	<key>CFBundleSignature</key>
	<string>????</string>
	<key>CFBundleVersion</key>
	<string>1.0</string>
	<key>CSResourcesFileMapped</key>
	<true/>
</dict>
</plist>
EOF
close(FILE);
