/* ScriptExecController */

#import <Cocoa/Cocoa.h>

// execution modes
#define	kNormalExecution	1
#define	kPrivilegedExecution	2

// output modes
#define	kNoOutput		1
#define	kProgressBarOutput	2
#define	kTextOutput		3

@interface ScriptExecController : NSObject
{
    IBOutlet id cancelButton;
    IBOutlet id messageTextField;
    IBOutlet id progressBar;
	IBOutlet id progressWindow;
	
	IBOutlet id textOutputWindow;
	IBOutlet id textOutputCancelButton;
	IBOutlet id textOutputTextField;
	
	NSTask			*task;
	NSMutableArray  *arguments;
	NSMutableArray  *fileArgs;
	NSString		*interpreter;
	NSString		*scriptPath;

	int			execStyle;
	int			outputType;
}
- (IBAction)cancel:(id)sender;
- (void)executeScript;
- (void)loadSettings;
@end
