//
//  FileList.m
//  Platypus
//
//  Created by Sveinbjorn Thordarson on Wed Feb 11 2004.
//  Copyright (c) 2004 __MyCompanyName__. All rights reserved.
//

#import "FileList.h"


@implementation FileList

- (id) init
{
		files = [[NSMutableArray alloc] init];
		return self;
}

-(void)dealloc
{
	[files release];
}



- (NSString *)getFileAtIndex:(int)index
{
	return [[files objectAtIndex: index] objectAtIndex: 0];
}

- (void) addFile: (NSString *)fileName
{
	NSImage *icon = [[NSWorkspace sharedWorkspace] iconForFile: fileName];
	[files addObject: [NSArray arrayWithObjects: fileName, icon, nil]];
}

- (void) addFiles: (NSArray *)fileNames
{
	NSImage *icon;
	int i;
	for (i = 0; i < [fileNames count]; i++)
	{
		icon = [[NSWorkspace sharedWorkspace] iconForFile: [fileNames objectAtIndex: i]];
		[files addObject: [NSArray arrayWithObjects: [fileNames objectAtIndex: i], icon, nil]];
	}
}

- (BOOL) hasFile: (NSString *)fileName
{
	int i;
	
	for (i = 0; i < [files count]; i++)
	{
		if ([[[files objectAtIndex: i] objectAtIndex: 0] isEqualToString: fileName])
			return YES;
	}
	return NO;
}

- (void) clearList
{
	[files removeAllObjects];
}

- (void) removeFile: (int)index
{
	[files removeObjectAtIndex: index];
}

- (int)numberOfRowsInTableView:(NSTableView *)aTableView
{
	return([files count]);
}

- (int)numFiles
{
	return([files count]);
}

- (NSArray *)getFilesArray
{
	NSMutableArray	*fileNames = [NSMutableArray arrayWithCapacity: 255];
	int				i;
	
	for (i = 0; i < [files count]; i++)
	{
		[fileNames addObject: [[files objectAtIndex: i] objectAtIndex: 0]];
	}

	return fileNames;
}


- (id)tableView:(NSTableView *)aTableView objectValueForTableColumn:(NSTableColumn *)aTableColumn row:(int)rowIndex
{
	if ([[aTableColumn identifier] caseInsensitiveCompare: @"2"] == NSOrderedSame)
	{
		return([[files objectAtIndex: rowIndex] objectAtIndex: 0]);
	}
	else if ([[aTableColumn identifier] caseInsensitiveCompare: @"1"] == NSOrderedSame)
	{
		if (rowIndex == 0)
		{
			NSImageCell* iconCell;
			iconCell = [[[NSImageCell alloc] init] autorelease];
			[aTableColumn setDataCell:iconCell];
		}
        
        return [[files objectAtIndex: rowIndex] objectAtIndex: 1];
	}
	return(@"");
}


- (void)revealInFinder: (int)index
{
	BOOL		isDir;
	NSString	*path = [[files objectAtIndex: index] objectAtIndex: 0];
	
	if ([[NSFileManager defaultManager] fileExistsAtPath:path isDirectory:&isDir]) 
	{
            if (isDir)
				[[NSWorkspace sharedWorkspace] selectFile:nil inFileViewerRootedAtPath:path];
            else
				[[NSWorkspace sharedWorkspace] selectFile:path inFileViewerRootedAtPath:nil];
	}
}
@end
