#include <Carbon/Carbon.h>


/************************************************************************************
**  DEFINITIONS
************************************************************************************/
#pragma mark - definitions

//script types
#define		kShellScriptType	0
#define		kPerlScriptType		1

//number of icons available
#define		kNumIcons	8

//author
#define		kAuthorEmail		"sveinbt@hi.is"
#define		kPlatypusWebsite	"http://raunvis.hi.is/~ssv/platypus.html"

//default settings
#define		kDefaultAppName		"MyApp"

//limits
#define		kMaxFileNameLength	255
#define		kMaxPathLength		2048


/************************************************************************************
**  PROTOTYPES
************************************************************************************/
#pragma mark - prototypes


	// main.c
	int main(int argc, char* argv[]);
	void QuitApp (void);

	OSErr InitHandlers (void);
	OSErr InitPaths (char *argvZero);
	OSErr InitNib (WindowRef *window);
	OSErr InitControls (void);
	OSErr InitIcons (void);

	OSErr NewPlatypusWindow (WindowRef window);
	void ClosePlatypusWindow (WindowRef window);

	OSErr CreateScriptApplication (void);
	
	OSErr SetIcon (short iconNum);
	
	OSErr NavigationPutPath (Str255 defaultName, Str255 promptMessage, char *path);
	OSErr NavigationGetPath (char *navPath);
	OSErr NavigationGetFSSpec (FSSpec *file);
	OSErr NavigationPutFSSpec (Str255 message, Str255 defaultName, FSSpec *theFile);
	pascal Boolean NavFilterProc (AEDesc* theItem, void* info,  NavCallBackUserData callBackUD, NavFilterModes filterMode);

	pascal OSStatus PlatypusCommandHandler (EventHandlerCallRef inCallRef, EventRef inEvent, void * inUserData);
	pascal OSStatus PlatypusWindowHandler (EventHandlerCallRef inCallRef, EventRef inEvent, void * inUserData);
	pascal OSStatus AboutWindowHandler (EventHandlerCallRef inCallRef, EventRef inEvent, void * inUserData);
	static OSErr AppAEReopenHandler( const AppleEvent *appleEvt, AppleEvent* reply, UInt32 refcon );
	
	// util.c

	IconRef RegisterIcon( FourCharCode inCreator, FourCharCode inType, const char* inName );
	void DoAlert (Str255 errorString, Str255 expStr);
	void DoFatalAlert (Str255 errorString, Str255 expStr);
	void OpenURL (char *url);
	void SendMail (char *email);
	short UnixIsFolder (char *path);
	void CutFileFromPath (char *path);
	OSStatus FSMakePath(FSSpec file, UInt8 *path, UInt32 maxPathSize);




/************************************************************************************
**  STRUCTURES
************************************************************************************/
#pragma mark - structures

typedef struct
{
    IconRef	icon;
    char	iconName[255];
    char	fileName[2048];

} PlatypusIconStruct;




