//
//  FileList.m
//  Platypus
//
//  Created by Sveinbjorn Thordarson on Wed Feb 11 2004.
//  Copyright (c) 2004 __MyCompanyName__. All rights reserved.
//

#import "FileList.h"


@implementation FileList

- (id) init
{
		files = [[NSMutableArray alloc] init];
		return self;
}


- (NSString *)getFileAtIndex:(int)index
{
	return [files objectAtIndex: index];
}

- (void) addFile: (NSString *)fileName
{
	//NSLog(@"Adding file number %d, which happens to be %@", [files count], fileName);
	[files addObject: fileName];
}

- (void) clearList
{
	[files removeAllObjects];
}

- (void) removeFile: (int)index
{
	[files removeObjectAtIndex: index];
}

- (int)numberOfRowsInTableView:(NSTableView *)aTableView
{
	return([files count]);
}

- (int)numFiles
{
	return([files count]);
}


- (id)tableView:(NSTableView *)aTableView objectValueForTableColumn:(NSTableColumn *)aTableColumn row:(int)rowIndex
{
	return([files objectAtIndex: rowIndex]);
}


- (void) printList
{
	int i;
	
	for (i = 0; i < [files count]; i++)
	{
		NSLog(@"%@", [files objectAtIndex: i]);
	}
}

- (void)revealInFinder: (int)index
{
	BOOL		isDir;
	NSString	*path = [files objectAtIndex: index];
	
	if ([[NSFileManager defaultManager] fileExistsAtPath:path isDirectory:&isDir]) 
	{
            if (isDir)
            [[NSWorkspace sharedWorkspace] selectFile:nil inFileViewerRootedAtPath:path];
            else
            [[NSWorkspace sharedWorkspace] selectFile:path inFileViewerRootedAtPath:nil];
	}
}
@end
